/* 

   Habillage d'une courbe avec section  n cots ; aprs un tour, chaque bande de rang i   se raccorde   la bande i+k (k nombre de bandes sautes) 
   
    
Programme crit  par Alain Esculier en fvrier 2016 et mis en ligne sur Internet en juillet 2022


*/

#version 3.8;
global_settings { assumed_gamma 2. }  


#include "colors.inc"
#include "metals.inc" 
#include "glass.inc"
#include "stones.inc"  
/*
#declare Start    = -1.5;
#declare End      = 1.5;
#declare myclock = Start+(End-Start)*clock;
  */
    
camera  { perspective  location <-0,5,-30> look_at<-0.1,0.0,5> right 4/3*x angle 18   }  // rotate myclock*y }
light_source { <-10,30,-30> White }  // shadowless 
light_source { <10,30,-30>  White  shadowless}  //color <1,0.98,0.9>  // 
light_source { <4,-20,-30>  White   shadowless}   // color <1,0.95,0>*0.3 
background{   rgb <1,0.7,0.4>*0.5}   //   Black}   //    

 //-----------finish ----------------
#declare monfinish1=finish{ambient 0.4 diffuse 0.3  reflection 0.2 phong 0.5 phong_size 100} ;
#declare monfinish2=finish{ambient 0.2 diffuse 0.6 roughness 0.000001 reflection 0.0 phong 0.8 phong_size 20} ;

//=================== INITIALISATIONS POUR LES PARAMTRES DE TRACS, TRIDRE MOBILE =====================  

#declare numCourbe=4; 


#declare R=6; 
#declare r1=0.02;  //--- rayon des artes --------
#declare V=<0,0,1>;               //--- B orthogonal au plan (T,V) ; T vecteur tangent -----
           //--- CHOIX DE LA COURBE par son n compris entre 1 et 4   -----------
#declare Serret_Frenet= false;    //--- choix tridre 
// -----------NOMBRE DE FACES ; LARGEUR BANDE ; sauts aprs chaque tour ----------------------------- 
#declare NF=6; // nombre de faces
#declare L=0.8;// 1.5;  // largeur d'une bande  
#declare saut=2; //16;  
#declare coeffL=1;  // bande de largeur L ---> coeffL=1 , coeff <1 bandes disjointes 
#declare espaceSections=50; //---- espacement des sections de ce nombre de pas du paramtre de la courbe  

#declare traceBandes=true;   
#declare traceSections=true;  //sections non traces si coeffL < 1
#declare traceAretes=true;
 
//================ 4 courbes possibles =================================================
    

#switch(numCourbe)
      #case(1)
          //------------------- Noeud de trfle normalL ---------------------------- 
          #macro ML(uu)  <cos(uu)+2*cos(2*uu), sin(uu)-2*sin(2*uu),2*sin(3*uu)>    #end    
          #macro dMLu(uu)    <-sin(uu)-4*sin(2*uu), cos(uu)-4*cos(2*uu), 6*cos(3*uu)>     #end   
          #macro dML2u(uu)   <-cos(uu)-8*cos(2*uu), -sin(uu)+8*sin(2*uu), -18*sin(3*uu)> #end 
          #declare echelle=0.9;  
          #break
      #case(2)
          //------------------- TORE TORDU ---------------------------- 
          #macro ML(uu)      < R*cos(uu), R*sin(uu), R*sin(2*uu)> #end      
          #macro dMLu(uu)    < -R*sin(uu), R*cos(uu),2*R*cos(2*uu)> #end   
          #macro dML2u(uu)   < -R*cos(uu), -R*sin(uu), -4*R*sin(2*uu)> #end 
          #declare echelle=0.4;
          #break
      #case(3)
          //------------------- NOEUD TORIQUE ---------------------------- 
          #macro ML(uu)      #declare p=2; #declare q=3;
                            #declare R=6; #declare r=1.5;    
                           < (R+r*cos(q*uu))*cos(p*uu), (R+r*cos(q*uu))*sin(p*uu), r*sin(q*uu)>  #end//torique   p = nbre de tours q= nbre d'oscillations  
          #macro dMLu(uu)     #declare p=2; #declare q=3;
                        <-r*sin(q*uu)*q*cos(p*uu)-(R+r*cos(q*uu))*sin(p*uu)*p, -r*sin(q*uu)*q*sin(p*uu)+(R+r*cos(q*uu))*cos(p*uu)*p, r*cos(q*uu)*q >     #end   //torique
          #macro dML2u(uu)   // <0,0,1>    #end //rot(dMLu(uu),uu/NF,<0,0,1>)   #end //  //torique
                  #declare p=2; #declare q=3;
                   < -r*cos(q*uu)*q*q*cos(p*uu)+2*r*sin(q*uu)*q*sin(p*uu)*p-(R+r*cos(q*uu))*cos(p*uu)*p*p, -r*cos(q*uu)*q*q*sin(p*uu)-2*r*sin(q*uu)*q*cos(p*uu)*p-(R+r*cos(q*uu))*sin(p*uu)*p*p, -r*sin(q*uu)*q*q  >  #end  //torique
          #declare echelle=0.4;  
          #break
      #case(4)
         //------------------- TORE SIMPLE ---------------------------- 
          #macro ML(uu)      < R*cos(uu), R*sin(uu), 0> #end   
          #macro dMLu(uu)      < -R*sin(uu), R*cos(uu),0> #end  
          #macro dML2u(uu)     < -R*cos(uu), -R*sin(uu),0> #end   
          #declare echelle=0.4;  
          #break
      #break
#end
           

// ---------------------- choix le vecteur  B(uu) ------------------
#switch(Serret_Frenet)
     #case(true)   //----- utilisation Serret-Frenet 
           #macro B(uu) norm(vcross(dMLu(uu),dML2u(uu))) #end  #macro N(uu) vcross(B(uu),T(uu)) #end 
           #break
     #case(false)   //----- utilisation du vecteur V
           //------ souvent moins tordu qu'avec le prcdent ;(on peut aussi changer <0,0,1>selon la courbe !) ------
           #declare V= <0,0,1> ;            
           #macro B(uu) norm(vcross(dMLu(uu),V)) #end  
           #macro N(uu) vcross(B(uu),T(uu)) #end     
           #break
     #break
 #end 
//======================================================================

// ----------------------------------------
#macro norm(vec) vec/sqrt(vdot(vec,vec)) #end
// ----------------------------------------
#macro T(uu) norm(dMLu(uu)) #end
// ---------------------- choisir un vecteur convenable pour B(uu) (on peut aussi changer <0,0,1> dans le cas 2 selon la courbe !)------------------
 //#macro B(uu) norm(vcross(dMLu(uu),dML2u(uu))) #end  
#macro B(uu) norm(vcross(dMLu(uu),<0,0,1>)) #end      //--- souvent moins tordu qu'avec le prcdent ------
// ----------------------------------------      
#macro rot(axe,tt,pt) // rotation                           
    #local axe1=norm(axe);
   cos(tt)*pt +sin(tt)*vcross(axe1,pt) +(1-cos(tt))*vdot(axe1,pt)*axe1
#end 


// ---------------------------------------- 
 #macro J(uu,i,k) norm(rot(dMLu(uu),2*pi/NF*i+uu*k/NF,B(uu))) #end
  #macro K(uu,i,k) norm(rot(dMLu(uu),2*pi/NF*i+uu*k/NF+pi/2,B(uu))) #end
  #macro pt(uu,vv,i,k) ML(uu)+L/2/tan(pi/NF)*J(uu,i,k)+vv*K(uu,i,k) #end
// ---------------------------------------- 
#declare tabtex=array[8]{ T_Stone16 ,T_Stone18 ,T_Stone21 ,T_Stone27 ,T_Stone32 ,T_Stone41 ,T_Stone13 ,T_Stone35      };  
#declare tabcol=array[8]{ Cyan,Yellow ,Green*0.5 ,Magenta,Blue ,Copper,Silver,Red };

#macro bande(k,i) 
    union{//------- le trac -----
  #local n=800;  // nombre de pas pour le trac
  #local uiter=2*pi/n;  
  
   #local modcouleur= k;  //  k;  //=== changer pour modifier l'alternance des couleurs =====
 
  #local p1=pt(0,-L/2*coeffL,i,k);
  #local p2=pt(0,L/2*coeffL,i,k);
  #local j1=J(0,i,k);
   #for(cu,0,n-1,1)
     #local p3=pt((cu+1)*uiter,-L/2*coeffL,i,k); 
     #local p4=pt((cu+1)*uiter,L/2*coeffL,i,k);  // bande de largeur L*2/3 ---> mettre L/3 ( bandes disjointes
     #local j2=J((cu+1)*uiter,i,k); 
     #if(traceBandes)
        smooth_triangle{ p1,j1, p2,j1, p3,j2 }                         
        smooth_triangle{ p4,j2, p2,j1, p3,j2 }
     #end 
     #if(traceAretes)
         cylinder{p1,p3,r1 pigment{Gold}  finish{monfinish1 } }     // aretes
          #if(coeffL<1) cylinder{p2,p4, r1 pigment{Gold}}  #end//  supprimer si bande de largeur L  
     #end
     #if(traceSections & (coeffL=1))  
          #if( mod(cu,espaceSections)=0) cylinder{p1,p2,r1 pigment{Cyan }  finish{monfinish1 } }  #end   // section //-----augmenter n dans   mod(cu,n) pour sections plus espaces ----
     #end
     #local p1=p3;  #local p2=p4; #local j1=j2; 
 #end 
 
 
 }                   
#end
// ----------------------------------------

 
#declare graphe=
     union{
          #for(i,1,NF,1)  
          object{ bande(saut,i)
                 texture{tabtex[i]  scale 0.8   finish{monfinish2}   } 
                //  pigment{tabcol[mod(i-1,5)]  transmit 0.3}    finish{ambient 0.4 diffuse 0.2 roughness 0.000001 specular 0.8} 
                }      
       #end 
       };
//========    tracs ================================================================================       
       
 union{  object{graphe rotate -90*z  }     
         //  object{graphe scale sc  clipped_by{ box{<0,-2*R,-R>,<-1.5*R,2*R,R>}}   rotate -80*z   rotate <80,0,0> translate -2.1*y } 
           rotate <20,20,0>
           scale echelle   // ---- voir  initialisations //
           translate 0.5*y  // ----  adapter                                                                   
            }
// ---------------------------------------- 
 text {
    ttf "times.ttf" "AE"
    0.3, 0
    scale 0.3 
    rotate <-2,6,0>  
    translate <3,-2.5,0> 
    
    pigment{ White*0.8}
    finish{monfinish1} 
    }



                     
     